## albert 0.17.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.3)  # Least supporting CMAKE_CXX_STANDARD
###############################################################################

project(albert VERSION 0.17.2)

###############################################################################

include(GNUInstallDirs)

###############################################################################

add_definitions(-DALBERT_VERSION="${PROJECT_VERSION}")

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

# Set standard
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Set additional compiler flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic") #-Wconversion -Wunused
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DQT_QML_DEBUG")

# Color make output
SET(CMAKE_COLOR_MAKEFILE ON)

# Put the binaries in dedicated toplevel directories
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

###############################################################################

add_subdirectory(lib/globalshortcut)
add_subdirectory(lib/xdg)
add_subdirectory(plugins/)

###############################################################################

set(TARGET_NAME_LIB ${PROJECT_NAME}-lib)

file(GLOB_RECURSE LIB_SRC include/* src/lib/*)

add_library(${TARGET_NAME_LIB} SHARED ${LIB_SRC})
add_library(albert::lib ALIAS ${TARGET_NAME_LIB})

set_target_properties(${TARGET_NAME_LIB} PROPERTIES
    OUTPUT_NAME ${PROJECT_NAME}
    INSTALL_RPATH "$ORIGIN"
)

target_compile_definitions(${TARGET_NAME_LIB} PRIVATE -DCORE) #export branch

target_include_directories(${TARGET_NAME_LIB}
    PUBLIC
        include
    PRIVATE
        include/albert
        include/albert/util
        src/lib
)

find_package(Qt5 5.5.0
    COMPONENTS
        Gui
        Sql
)

target_link_libraries(${TARGET_NAME_LIB}
    PRIVATE
        Qt5::Gui
        Qt5::Sql
)

###############################################################################

option(BUILD_WITH_QTCHARTS "Use QtCharts to plot stats." ON)

find_package(Qt5 5.5.0
    COMPONENTS
        Concurrent
        Network
        Sql
        Widgets
        X11Extras
    OPTIONAL_COMPONENTS
        Charts
)

set(TARGET_NAME_BIN ${PROJECT_NAME}-bin)

file(GLOB_RECURSE BIN_SRC src/app/*)
if(NOT BUILD_WITH_QTCHARTS)  # TODO: remove Apr 2020
    list(REMOVE_ITEM BIN_SRC "${CMAKE_CURRENT_SOURCE_DIR}/src/app/settingswidget/statswidget.h")
    list(REMOVE_ITEM BIN_SRC "${CMAKE_CURRENT_SOURCE_DIR}/src/app/settingswidget/statswidget.cpp")
endif()

add_executable(${TARGET_NAME_BIN} ${BIN_SRC} resources.qrc)

set_target_properties(${TARGET_NAME_BIN} PROPERTIES
    OUTPUT_NAME ${PROJECT_NAME}
    INSTALL_RPATH "$ORIGIN/../${CMAKE_INSTALL_LIBDIR}/albert/"  # Set the RPATH for the library lookup
)

target_include_directories(${TARGET_NAME_BIN} PRIVATE src/app src/app/settingswidget)
if (DEFINED CMAKE_LIBRARY_ARCHITECTURE)
    target_compile_definitions(${TARGET_NAME_BIN} PRIVATE -DMULTIARCH_TUPLE="${CMAKE_LIBRARY_ARCHITECTURE}")
endif()

target_link_libraries(${TARGET_NAME_BIN}
    PRIVATE
        Qt5::Concurrent
        Qt5::Network
        Qt5::Sql
        Qt5::Widgets
        Qt5::X11Extras
        albert::lib
        globalshortcut
        xdg
)
if(BUILD_WITH_QTCHARTS)
    target_link_libraries(${TARGET_NAME_BIN} PRIVATE Qt5::Charts)
    target_compile_definitions(${TARGET_NAME_BIN} PRIVATE -DBUILD_WITH_QTCHARTS) #export branch
endif()

###############################################################################

install(TARGETS ${TARGET_NAME_LIB} ${TARGET_NAME_BIN}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/albert
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

# Do platform specific post target stuff
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    # Install desktop entry and icon
   install(FILES resources/albert.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications )
   install(FILES resources/icons/albert.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
endif (${CMAKE_SYSTEM_NAME} MATCHES "Linux")

=== lib/CMakeLists.txt ===
# Do not export symbols by default
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)

add_subdirectory(albertcore)
add_subdirectory(xdg)
add_subdirectory(globalshortcut)

=== plugins/CMakeLists.txt ===
# Do not export symbols by default
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)

# Set the RPATH for the library lookup
set(CMAKE_INSTALL_RPATH "$ORIGIN/../")

# FrontendPlugins

option(BUILD_WIDGETBOXMODEL "Build the frontend" ON)
if (BUILD_WIDGETBOXMODEL)
    add_subdirectory(widgetboxmodel)
endif()

option(BUILD_QMLBOXMODEL "Build the frontend" ON)
if (BUILD_QMLBOXMODEL)
    add_subdirectory(qmlboxmodel)
endif()



# ExtensionPlugins

option(BUILD_APPLICATIONS "Build the extension" ON)
if (BUILD_APPLICATIONS)
    add_subdirectory(applications)
endif()

option(BUILD_CALCULATOR "Build the extension" ON)
if (BUILD_CALCULATOR)
    add_subdirectory(calculator)
endif()

option(BUILD_CHROMEBOOKMARKS "Build the extension" ON)
if (BUILD_CHROMEBOOKMARKS)
    add_subdirectory(chromium)
endif()

option(BUILD_DEBUG "Build the extension" OFF)
if (BUILD_DEBUG)
    add_subdirectory(debug)
endif()

option(BUILD_FILES "Build the extension" ON)
if (BUILD_FILES)
    add_subdirectory(files)
endif()

option(BUILD_FIREFOXBOOKMARKS "Build the extension" ON)
if (BUILD_FIREFOXBOOKMARKS)
    add_subdirectory(firefoxbookmarks)
endif()

option(BUILD_HASHGENERATOR "Build the extension" ON)
if (BUILD_HASHGENERATOR)
    add_subdirectory(hashgenerator)
endif()

option(BUILD_MPRIS "Build the extension" ON)
if (BUILD_MPRIS)
    add_subdirectory(mpris)
endif()

option(BUILD_PYTHON "Build the extension" ON)
if (BUILD_PYTHON)
    add_subdirectory(python)
endif()

option(BUILD_SNIPPETS "Build the extension" ON)
if (BUILD_SNIPPETS)
    add_subdirectory(snippets)
endif()

option(BUILD_SSH "Build the extension" ON)
if (BUILD_SSH)
    add_subdirectory(ssh)
endif()

option(BUILD_SYSTEM "Build the extension" ON)
if (BUILD_SYSTEM)
    add_subdirectory(system)
endif()

option(BUILD_TEMPLATE "Build the extension" OFF)
if (BUILD_TEMPLATE)
    add_subdirectory(templateExtension)
endif()

option(BUILD_TERMINAL "Build the extension" ON)
if (BUILD_TERMINAL)
    add_subdirectory(terminal)
endif()

option(BUILD_VIRTUALBOX "Build the extension" OFF)  # Deprecated
if (BUILD_VIRTUALBOX)
    add_subdirectory(virtualbox)
endif()

option(BUILD_WEBSEARCH "Build the extension" ON)
if (BUILD_WEBSEARCH)
    add_subdirectory(websearch)
endif()

=== lib/globalshortcut/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.3)

project(globalshortcut)

find_package(Qt5 5.5.0 REQUIRED COMPONENTS Gui)

set(SRC
    include/globalshortcut/globalshortcut_globals.h
    include/globalshortcut/hotkeymanager.h
    src/hotkeymanager.cpp
)

set(LIB Qt5::Gui)

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux" OR ${CMAKE_SYSTEM_NAME} MATCHES "^(FreeBSD|DragonFly)$")
    find_package(Qt5 5.5.0 REQUIRED X11Extras)
    set(SRC ${SRC} src/hotkeymanager_x11.cpp)
    set(LIB ${LIB} Qt5::X11Extras X11)

#elseif(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
#    set(SRC ${SRC} src/hotkeymanager_win.cpp)
#    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DUNICODE")

elseif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(SRC ${SRC} src/hotkeymanager_mac.cpp)

endif()

add_library(${PROJECT_NAME} STATIC ${SRC})

target_compile_definitions(${PROJECT_NAME} PRIVATE -DGLOBALSHORTCUT) #export branch

target_include_directories(${PROJECT_NAME}
    PUBLIC
        include
    PRIVATE
        include/globalshortcut
        src
)

target_link_libraries(${PROJECT_NAME} PRIVATE ${LIB})

=== lib/xdg/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.3)

project(xdg)

find_package(Qt5 5.5.0 REQUIRED COMPONENTS Gui)

file(GLOB SRC src/* include/xdg/*)

add_library(${PROJECT_NAME} SHARED ${SRC})

target_compile_definitions(${PROJECT_NAME} PRIVATE -DXDG_DEF) #export branch

target_include_directories(${PROJECT_NAME}
    PUBLIC
        include
    PRIVATE
        include/xdg
        src
)

target_link_libraries(${PROJECT_NAME} PRIVATE Qt5::Gui)

install(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/albert)

=== plugins/applications/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.3)

project(applications)

file(GLOB_RECURSE SRC src/*)

find_package(Qt5 5.5.0 REQUIRED COMPONENTS Widgets Concurrent)

add_library(${PROJECT_NAME} SHARED ${SRC} ${PROJECT_NAME}.qrc metadata.json)

target_include_directories(${PROJECT_NAME} PRIVATE src/)

target_link_libraries(${PROJECT_NAME}
    PRIVATE
        Qt5::Concurrent
        Qt5::Widgets
        albert::lib
        xdg
)

install(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/albert/plugins)

=== plugins/chromium/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.3)

project(chromium)

file(GLOB_RECURSE SRC src/*)

find_package(Qt5 5.5.0 REQUIRED COMPONENTS Widgets Concurrent)

add_library(${PROJECT_NAME} SHARED ${SRC} ${PROJECT_NAME}.qrc metadata.json)

target_include_directories(${PROJECT_NAME} PRIVATE src/)

target_link_libraries(${PROJECT_NAME}
    PRIVATE
        Qt5::Widgets
        Qt5::Concurrent
        albert::lib
        xdg
)

install(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/albert/plugins)

=== plugins/debug/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.3)

project(debug)

file(GLOB_RECURSE SRC src/* metadata.json)

find_package(Qt5 5.5.0 REQUIRED COMPONENTS Widgets)

add_library(${PROJECT_NAME} SHARED ${SRC} ${PROJECT_NAME}.qrc)

target_include_directories(${PROJECT_NAME} PRIVATE src/)

target_link_libraries(${PROJECT_NAME}
    PRIVATE
        Qt5::Widgets
        albert::lib
)

install(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/albert/plugins)

=== plugins/files/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.3)

project(files)

file(GLOB_RECURSE SRC src/*)

find_package(Qt5 5.5.0 REQUIRED COMPONENTS Widgets Concurrent)

add_library(${PROJECT_NAME} SHARED ${SRC} ${PROJECT_NAME}.qrc metadata.json)

target_include_directories(${PROJECT_NAME} PRIVATE src/)

target_link_libraries(${PROJECT_NAME}
    PRIVATE
        Qt5::Concurrent
        Qt5::Widgets
        albert::lib
        xdg
)

install(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/albert/plugins)

=== plugins/firefoxbookmarks/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.3)

project(firefoxbookmarks)

file(GLOB_RECURSE SRC src/*)

find_package(Qt5 5.5.0 REQUIRED COMPONENTS Widgets Concurrent Sql)

add_library(${PROJECT_NAME} SHARED ${SRC} ${PROJECT_NAME}.qrc metadata.json)

target_include_directories(${PROJECT_NAME} PRIVATE src/)

target_link_libraries(${PROJECT_NAME}
    PRIVATE
        Qt5::Concurrent
        Qt5::Sql
        Qt5::Widgets
        albert::lib
        xdg
)

install(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/albert/plugins)

=== plugins/mpris/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.3)

project(mpris)

file(GLOB_RECURSE SRC src/*)

find_package(Qt5 5.5.0 REQUIRED COMPONENTS Widgets DBus)

add_library(${PROJECT_NAME} SHARED ${SRC} ${PROJECT_NAME}.qrc metadata.json)

target_include_directories(${PROJECT_NAME} PRIVATE src/)

target_link_libraries(${PROJECT_NAME}
    PRIVATE
        Qt5::DBus
        Qt5::Widgets
        albert::lib
        xdg
)

install(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/albert/plugins)

=== plugins/python/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.3)

PROJECT(python)

FILE(GLOB_RECURSE SRC src/*)

find_package(Qt5 5.5.0 REQUIRED COMPONENTS Widgets)
add_subdirectory(pybind11)

add_library(${PROJECT_NAME} SHARED ${SRC} ${PROJECT_NAME}.qrc metadata.json)

target_include_directories(${PROJECT_NAME} PRIVATE src/)

target_link_libraries(${PROJECT_NAME}
    PUBLIC
        Qt5::Widgets
    PRIVATE
        pybind11::embed
        albert::lib
        xdg
)

install(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/albert/plugins)
install(DIRECTORY "share/" DESTINATION "${CMAKE_INSTALL_DATADIR}/albert/org.albert.extension.python")

=== debian/changelog ===
albert (0.17.2-0~mx21+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-21.
  * Switch to 3.0 (quilt) source format.
  * Add debian/copyright.
  * Clean up formatting in debian/control.
  * debian/rules:
    - enable full hardening.
    - disable automatic dbgsym packages.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Wed, 01 Sep 2021 12:34:16 -0400

albert (0.17.2-0) stable; urgency=low

  * Albert Upstream Release
  
 -- Manuel Schneider <manuelschneid3r@gmail.com>  Sun, 29 Oct 2017 00:00:00 +0000

=== debian/control ===
Source: albert
Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
XSBC-Original-Maintainer: Manuel Schneider <manuelschneid3r@gmail.com>
Section: utils
Priority: optional
Standards-Version: 4.1.0
Build-Depends: 
	debhelper (>=10),
	cmake (>=3.1.3),
	qtbase5-dev (>=5.5),
	libqt5x11extras5-dev (>=5.5),
	libqt5svg5-dev (>=5.5),
	qtdeclarative5-dev (>=5.5),
	libmuparser-dev (>=2),
	python3-dev (>=3.5),
	lsb-release
Homepage: https://albertlauncher.github.io/
Vcs-Browser: https://github.com/albertlauncher
Vcs-Git: https://github.com/albertlauncher/albert.git

Package: albert
Architecture: any
Depends:
 ${shlibs:Depends},
 libqt5sql5-sqlite,
 qml-module-qtgraphicaleffects,
 qml-module-qtquick-controls
Description: sophisticated, plugin-based, standalone keyboard launcher
 Albert is a unified and efficient access to your machine. Technically it is a
 keyboard launcher written in C++/Qt. The plugin based architecture makes it
 extremely flexible and powerful. Plugins can be used to create modular 
 frontends or native extensions. Extensions can also be implemented using 
 embedded Python modules or via a CGI approach in any language you want. The 
 frontends shipped heavily focus on customizability.

=== debian/rules ===
#!/usr/bin/make -f
CODENAME = $(shell lsb_release -cs)
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export QT_SELECT=5


%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release -DBUILD_WITH_QTCHARTS=OFF -DBUILD_VIRTUALBOX=OFF

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## albert 0.24.2

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 Manuel Schneider

cmake_minimum_required(VERSION 3.22)  # Ubuntu 22.04

# dont touch! set by metatool
set(PROJECT_VERSION 0.24.2)

project(albert
    VERSION ${PROJECT_VERSION}
    DESCRIPTION "Keyboard launcher"
    HOMEPAGE_URL "https://albertlauncher.github.io"
)

# Local cmake modules (also CMake uses this in a pretty obscure way, e.g. for the plist)
list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

set(ALBERT_COMPILE_OPTIONS
    #-Werror
    -Wall
    -Wextra
    -Wpedantic

    # -Wconversion
    # -Weffc++
    -Winline
    -Wmissing-field-initializers
    -Wreturn-type
    -Wshadow
    -Wstrict-aliasing

    # Use this from time to time
    # -Weverything
    # -Wdocumentation
    # -Wno-c++98-compat
    # -Wno-c++20-compat
    # -Wno-c++98-compat-pedantic

    # ??
    # -Wl,-undefined
)

# Put the binaries in dedicated toplevel directories
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)


### Dependencies ##############################################################

# QNotification

add_subdirectory(lib/QNotification EXCLUDE_FROM_ALL)

# QHotkey

set(QT_DEFAULT_MAJOR_VERSION 6)
set(BUILD_SHARED_LIBS FALSE)
set(QHOTKEY_INSTALL OFF CACHE BOOL "" FORCE)
add_subdirectory(lib/QHotkey EXCLUDE_FROM_ALL)
target_compile_options(qhotkey PRIVATE -Wno-gnu-zero-variadic-macro-arguments -Wno-unused-parameter -Wno-shadow)


### Lib  ######################################################################

set(TARGET_LIB lib${PROJECT_NAME})

set(LIB_PUBLIC_HEADER
    ${PROJECT_BINARY_DIR}/include/albert/config.h  # generated
    ${PROJECT_BINARY_DIR}/include/albert/export.h  # generated

    include/albert/action.h
    include/albert/backgroundexecutor.h
    include/albert/extension.h
    include/albert/extensionplugin.h
    include/albert/extensionregistry.h
    include/albert/extensionwatcher.h
    include/albert/fallbackhandler.h
    include/albert/frontend.h
    include/albert/globalqueryhandler.h
    include/albert/iconprovider.h
    include/albert/indexitem.h
    include/albert/indexqueryhandler.h
    include/albert/inputhistory.h
    include/albert/item.h
    include/albert/logging.h
    include/albert/matchconfig.h
    include/albert/matcher.h
    include/albert/notification.h
    include/albert/plugindependency.h
    include/albert/plugininstance.h
    include/albert/pluginloader.h
    include/albert/pluginmetadata.h
    include/albert/pluginprovider.h
    include/albert/property.h
    include/albert/query.h
    include/albert/rankitem.h
    include/albert/standarditem.h
    include/albert/triggerqueryhandler.h
    include/albert/util.h
)

set(LIB_SRC
    src/app/app.cpp
    src/app/app.h
    src/app/appqueryhandler.cpp
    src/app/appqueryhandler.h
    src/app/messagehandler.cpp
    src/app/messagehandler.h
    src/app/pluginqueryhandler.cpp
    src/app/pluginqueryhandler.h
    src/app/qtpluginloader.cpp
    src/app/qtpluginloader.h
    src/app/qtpluginprovider.cpp
    src/app/qtpluginprovider.h
    src/app/report.cpp
    src/app/report.h
    src/app/rpcserver.cpp
    src/app/rpcserver.h
    src/app/triggersqueryhandler.cpp
    src/app/triggersqueryhandler.h
    src/app/telemetry.cpp
    src/app/telemetry.h
    src/app/terminalprovider.cpp
    src/app/terminalprovider.h

    src/common/action.cpp
    src/common/extension.cpp
    src/common/item.cpp
    src/common/rankitem.cpp

    src/frontend/frontend.cpp
    src/frontend/inputhistory.cpp
    src/frontend/itemsmodel.cpp
    src/frontend/itemsmodel.h
    src/frontend/session.cpp
    src/frontend/session.h

    src/platform/platform.h

    src/plugin/extensionregistry.cpp
    src/plugin/plugin.cpp
    src/plugin/plugin.h
    src/plugin/plugininstance.cpp
    src/plugin/pluginloader.cpp
    src/plugin/pluginprovider.cpp
    src/plugin/pluginregistry.cpp
    src/plugin/pluginregistry.h
    src/plugin/topologicalsort.hpp

    src/query/fallbackhandler.cpp
    src/query/globalqueryhandler.cpp
    src/query/query.cpp
    src/query/queryengine.cpp
    src/query/queryengine.h
    src/query/queryexecution.cpp
    src/query/queryexecution.h
    src/query/triggerqueryhandler.cpp
    src/query/usagedatabase.cpp
    src/query/usagedatabase.h

    src/settings/pluginswidget/pluginsmodel.cpp
    src/settings/pluginswidget/pluginsmodel.h
    src/settings/pluginswidget/pluginswidget.cpp
    src/settings/pluginswidget/pluginswidget.h

    src/settings/querywidget/fallbacksmodel.cpp
    src/settings/querywidget/fallbacksmodel.h
    src/settings/querywidget/queryhandlermodel.cpp
    src/settings/querywidget/queryhandlermodel.h
    src/settings/querywidget/querywidget.cpp
    src/settings/querywidget/querywidget.h

    src/settings/settingswindow.cpp
    src/settings/settingswindow.h

    src/util/extensionplugin.cpp
    src/util/iconprovider.cpp
    src/util/indexitem.cpp
    src/util/indexqueryhandler.cpp
    src/util/itemindex.cpp
    src/util/itemindex.h
    src/util/levenshtein.cpp
    src/util/levenshtein.h
    src/util/matcher.cpp
    src/util/notification.cpp
    src/util/standarditem.cpp
    src/util/util.cpp

    src/config.h.in
)

if (APPLE)
    list(APPEND LIB_SRC
        src/platform/mac/platform.mm
    )
else()  # assume xdg
    list(APPEND LIB_SRC
        src/platform/xdg/iconlookup.cpp
        src/platform/xdg/iconlookup.h
        src/platform/xdg/platform.cpp
        src/platform/xdg/themefileparser.cpp
        src/platform/xdg/themefileparser.h
    )
endif()

if (UNIX)
    list(APPEND LIB_SRC
        src/platform/unix/unixsignalhandler.cpp
        src/platform/unix/unixsignalhandler.h
    )
endif()

set(LIB_UI
    src/settings/querywidget/querywidget.ui
    src/settings/settingswindow.ui
)

add_library(${TARGET_LIB} SHARED
    ${LIB_PUBLIC_HEADER}
    ${LIB_SRC}
    ${LIB_UI}
    resources/resources.qrc
)

add_library("${PROJECT_NAME}::${TARGET_LIB}" ALIAS ${TARGET_LIB})

include(GNUInstallDirs)
include(GenerateExportHeader)

generate_export_header(${TARGET_LIB}
    BASE_NAME ${PROJECT_NAME}
    EXPORT_FILE_NAME "${PROJECT_BINARY_DIR}/include/albert/export.h"
)

target_compile_options(${TARGET_LIB} PRIVATE ${ALBERT_COMPILE_OPTIONS})

target_include_directories(${TARGET_LIB}
    PUBLIC
        "$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include/>"
        "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/>"
        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
    PRIVATE
        "${PROJECT_BINARY_DIR}/include/albert"
        "${PROJECT_SOURCE_DIR}/include/albert"
        src
        src/app
        src/common
        src/frontend
        src/handlers
        src/platform
        src/platform/mac
        src/platform/unix
        src/platform/xdg
        src/plugin
        src/query
        src/settings
        src/settings/pluginswidget
        src/settings/querywidget
        src/util
)

configure_file(
    "${PROJECT_SOURCE_DIR}/src/config.h.in"
    "${PROJECT_BINARY_DIR}/include/albert/config.h"
    @ONLY
)

find_package(Qt6 6.2 REQUIRED COMPONENTS # Ubuntu 22.04
    Core
    Concurrent
    Network
    Sql
    Svg
    Widgets
    LinguistTools
)

target_link_libraries(${TARGET_LIB}
    PRIVATE
        QHotkey::QHotkey
        QNotifications::QNotifications
        Qt6::Concurrent
        Qt6::Core
        Qt6::Network
        Qt6::Sql
        Qt6::Widgets
)

if(APPLE)
    target_link_libraries(${TARGET_LIB}
        PRIVATE objc "-framework Cocoa"
    )
elseif(UNIX)
    if (DEFINED CMAKE_LIBRARY_ARCHITECTURE)
        target_compile_definitions(${TARGET_LIB}
            PRIVATE -DMULTIARCH_TUPLE="${CMAKE_LIBRARY_ARCHITECTURE}"
        )
    endif()
endif()

set_target_properties(${TARGET_LIB} PROPERTIES
    #INSTALL_RPATH "$ORIGIN"
    CXX_STANDARD 20
    CXX_STANDARD_REQUIRED ON
    CXX_EXTENSIONS OFF
    CXX_VISIBILITY_PRESET hidden
    FRAMEWORK TRUE
    FRAMEWORK_VERSION A
    MACOSX_FRAMEWORK_BUNDLE_VERSION "${PROJECT_VERSION}"
    MACOSX_FRAMEWORK_IDENTIFIER "org.albertlauncher.albert.interface"
    MACOSX_FRAMEWORK_SHORT_VERSION_STRING ${PROJECT_VERSION}
    OUTPUT_NAME "${PROJECT_NAME}"
    PUBLIC_HEADER "${LIB_PUBLIC_HEADER}"
    SOVERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}"  # also mach-o compat version
    # NO_SONAME true # do _not_ add. linkers other that ldd will make troubles using non relative paths
    VERSION ${PROJECT_VERSION}
    VISIBILITY_INLINES_HIDDEN 1
    AUTOMOC ON
    AUTOUIC ON
    AUTORCC ON
)

### Internationalization

file(GLOB TS_FILES i18n/*.ts)

# Source files to be translated (separate because some files may be masked)
file(GLOB_RECURSE TRANSLATION_SOURCE_FILES
    include/.h
    src/*.h
    src/*.ui
    src/*.mm
    src/*.cpp
)

qt_add_translations(
    ${TARGET_LIB}
    TS_FILES ${TS_FILES}
    SOURCES ${TRANSLATION_SOURCE_FILES}
    # LUPDATE_OPTIONS -no-obsolete
)

# For convenience, QtCreator does not show the umbrella target
add_custom_target(global_lupdate DEPENDS update_translations)

### Export/Install

include(CMakePackageConfigHelpers)

set(LIB_EXPORT_NAME "${PROJECT_NAME}-targets")
set(LIB_TARGETS_FILE "${LIB_EXPORT_NAME}.cmake")
set(LIB_CONFIG_FILE "${PROJECT_NAME}-config.cmake")
set(LIB_VERSION_FILE "${PROJECT_NAME}-config-version.cmake")
set(LIB_MACROS_FILE "${PROJECT_NAME}-macros.cmake")
set(LIB_FIND_ALBERT_FILE "FindAlbert.cmake")
set(LIB_CMAKE_MODULE_DIR "${PROJECT_SOURCE_DIR}/cmake")
set(INSTALL_CONFIGDIR "${CMAKE_INSTALL_LIBDIR}/cmake/Albert")

# Install the target
# https://cmake.org/cmake/help/latest/command/install.html#targets
install(
    TARGETS ${TARGET_LIB}
    EXPORT ${LIB_EXPORT_NAME}  # just an association
    FRAMEWORK DESTINATION .
    INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/albert
)

# Create a targets file in install tree
# https://cmake.org/cmake/help/latest/command/install.html#export
# By default the generated file will be called <export-name>.cmake
install(
    EXPORT ${LIB_EXPORT_NAME}
    NAMESPACE ${PROJECT_NAME}::
    DESTINATION ${INSTALL_CONFIGDIR}
)

# Create a targets file in build tree (matching install(EXPORT))
# https://cmake.org/cmake/help/latest/command/export.html#exporting-targets-matching-install-export
# Seems like a shorthand for export(TARGETS)
export(
   EXPORT ${LIB_EXPORT_NAME}
   NAMESPACE ${PROJECT_NAME}::
   FILE "${PROJECT_BINARY_DIR}/${LIB_TARGETS_FILE}"
)

include(CMakePackageConfigHelpers)

# Create version file in build tree
write_basic_package_version_file(
    "${PROJECT_BINARY_DIR}/${LIB_VERSION_FILE}"
    VERSION "${PROJECT_VERSION}"
    COMPATIBILITY AnyNewerVersion
)

# Create config file in build tree
configure_package_config_file(
   "${LIB_CMAKE_MODULE_DIR}/${LIB_CONFIG_FILE}.in"
   "${PROJECT_BINARY_DIR}/${LIB_CONFIG_FILE}"
   INSTALL_DESTINATION ${INSTALL_CONFIGDIR}
)

# Copy the macros to the build directory
configure_file(
    "${LIB_CMAKE_MODULE_DIR}/${LIB_MACROS_FILE}"
    "${PROJECT_BINARY_DIR}/${LIB_MACROS_FILE}"
    COPYONLY
)

# Copy the dummy FindAlbert to the build directory
configure_file(
    "${LIB_CMAKE_MODULE_DIR}/${LIB_FIND_ALBERT_FILE}.in"
    "${PROJECT_BINARY_DIR}/${LIB_FIND_ALBERT_FILE}"
    @ONLY
)

install(FILES
    "${PROJECT_BINARY_DIR}/${LIB_CONFIG_FILE}"
    "${PROJECT_BINARY_DIR}/${LIB_VERSION_FILE}"
    "${PROJECT_BINARY_DIR}/${LIB_MACROS_FILE}"
    DESTINATION ${INSTALL_CONFIGDIR}
)


### App  ######################################################################

set(TARGET_APP ${CMAKE_PROJECT_NAME})

add_executable(${TARGET_APP} MACOSX_BUNDLE "src/main.cpp")

if (APPLE)

    set(ICON_NAME "albert")
    set(ICON_PATH "dist/macos/${ICON_NAME}.icns")
    target_sources(${TARGET_APP} PRIVATE ${ICON_PATH})

    set_source_files_properties(${ICON_PATH} PROPERTIES MACOSX_PACKAGE_LOCATION Resources)

    set_target_properties(${TARGET_APP} PROPERTIES
        BUNDLE True
        MACOSX_BUNDLE TRUE

=== lib/QNotification/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 Manuel Schneider
# SPDX-License-Identifier: MIT

cmake_minimum_required(VERSION 3.16)

project(qnotifications VERSION 1.0)

set(REQUIRED_QT_VERSION 6.0.0)
find_package(Qt6 ${REQUIRED_QT_VERSION} COMPONENTS Core REQUIRED)

set(PUBLIC_HEADER
    include/qnotification.h
    ${PROJECT_BINARY_DIR}/qnotifications_export.h
)

add_library(${PROJECT_NAME} STATIC
    ${PUBLIC_HEADER}
    src/qnotification.cpp
    src/qnotificationmanager.h
)
add_library(QNotifications::QNotifications ALIAS ${PROJECT_NAME})

target_include_directories(${PROJECT_NAME}
    PUBLIC
        "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>"
        "$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>"
        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
    PRIVATE
        src/
)

target_link_libraries(${PROJECT_NAME} PRIVATE Qt6::Core)

include(GenerateExportHeader)
generate_export_header(${PROJECT_NAME})

target_include_directories(${PROJECT_NAME} PRIVATE ${PROJECT_BINARY_DIR})

if(WIN32)

    target_sources(${PROJECT_NAME} PRIVATE
        src/qnotification_win.cpp
        # src/qnotificationmanager_win.cpp
    )

elseif(APPLE)

    target_sources(${PROJECT_NAME} PRIVATE
        src/qnotificationmanager_mac.mm
    )

    set_source_files_properties(
        src/qnotificationmanager_mac.mm
        PROPERTIES COMPILE_FLAGS "-fobjc-arc"
    )

    target_link_libraries(${PROJECT_NAME}
        # PRIVATE "-framework Cocoa"
    )

elseif(UNIX)  # assume xdg

    target_sources(${PROJECT_NAME} PRIVATE
        src/qnotificationmanager_xdg.cpp
    )

    find_package(Qt6 COMPONENTS DBus REQUIRED)

    qt_add_dbus_interface(GENERATED_DBUS org.freedesktop.Notifications.xml xdgnotificationsinterface)

    target_sources(${PROJECT_NAME} PRIVATE
        ${GENERATED_DBUS}
        org.freedesktop.Notifications.xml
    )

    target_link_libraries(${PROJECT_NAME} PRIVATE Qt6::DBus)

else()

    message(FATAL_ERROR "Unsupported platform")

endif()


set_target_properties(${PROJECT_NAME} PROPERTIES
    POSITION_INDEPENDENT_CODE ON
    AUTOMOC ON
)

=== plugins/applications/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
find_package(Albert REQUIRED)

project(applications VERSION 11.0)

albert_plugin(
    SOURCES
        src/plugin.cpp
        src/plugin.h
    I18N_SOURCES
        src/*.h
        src/*.cpp
        src/*.mm
        src/*.ui
    QT
        Widgets
        Concurrent
)

if(APPLE)
    target_compile_options(${PROJECT_NAME} PRIVATE "-fobjc-arc")
    target_link_libraries(${PROJECT_NAME} PRIVATE objc "-framework Cocoa")
    target_sources(${PROJECT_NAME} PRIVATE
        src/configwidget_mac.ui
        src/plugin_mac.mm
    )
elseif(UNIX)
    target_sources(${PROJECT_NAME} PRIVATE
        src/configwidget_xdg.ui
        src/plugin_xdg.cpp
    )
endif()

=== plugins/bluetooth/CMakeLists.txt ===
if(APPLE)

    cmake_minimum_required(VERSION 3.16)
    find_package(Albert REQUIRED)

    project(bluetooth VERSION 1.0)

    albert_plugin(
        LINK PRIVATE "objc" "-framework IOBluetooth"
        QT Core
    )

    target_compile_options(${PROJECT_NAME} PRIVATE "-fobjc-arc")

endif()

=== plugins/calculator_qalculate/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
find_package(Albert REQUIRED)

project(calculator_qalculate VERSION 5.1)

find_package(PkgConfig REQUIRED)
pkg_check_modules(LIBQALCULATE REQUIRED libqalculate)

albert_plugin(
    INCLUDE SYSTEM PRIVATE
        ${LIBQALCULATE_INCLUDE_DIRS}
    LINK PRIVATE
        ${LIBQALCULATE_LIBRARIES}
    QT Widgets
)

target_link_directories(${PROJECT_NAME} PRIVATE ${LIBQALCULATE_LIBRARY_DIRS})

=== plugins/chromium/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
find_package(Albert REQUIRED)

project(chromium VERSION 7.0)

albert_plugin(QT Widgets Concurrent)

=== plugins/clipboard/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
find_package(Albert REQUIRED)

project(clipboard VERSION 3.1)

albert_plugin(
    INCLUDE PRIVATE $<TARGET_PROPERTY:albert::snippets,INTERFACE_INCLUDE_DIRECTORIES>
    QT Widgets
)

=== plugins/contacts_macos/CMakeLists.txt ===
if(APPLE)

cmake_minimum_required(VERSION 3.16)
find_package(Albert REQUIRED)

project(contacts_macos VERSION 4.1)

find_library(CONTACTS_FRAMEWORK Contacts)

albert_plugin(
    LINK PRIVATE ${CONTACTS_FRAMEWORK}
    QT Widgets
)

target_compile_options(${PROJECT_NAME} PRIVATE "-fobjc-arc")

endif()

=== plugins/datetime/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
find_package(Albert REQUIRED)

project(datetime VERSION 5.1)

albert_plugin(QT Widgets)

=== plugins/debug/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
find_package(Albert REQUIRED)

project(debug VERSION 0.0)

albert_plugin(QT Core)

=== plugins/dictionary/CMakeLists.txt ===
if(APPLE)

    cmake_minimum_required(VERSION 3.16)
    find_package(Albert REQUIRED)

    project(dictionary VERSION 3.1)

    find_library(CORESERVICES_LIBRARY CoreServices)

    albert_plugin(
        LINK PRIVATE ${CORESERVICES_LIBRARY}
        QT Core
    )

    target_compile_options(${PROJECT_NAME} PRIVATE "-fobjc-arc")

endif()

=== plugins/docs/CMakeLists.txt ===
if(NOT APPLE)

    cmake_minimum_required(VERSION 3.16)
    find_package(Albert REQUIRED)

    project(docs VERSION 6.5)

    find_package(LibArchive REQUIRED)

    albert_plugin(
        LINK PRIVATE LibArchive::LibArchive
        QT Network Sql Widgets
    )

endif()

=== debian/changelog ===
albert (0.24.2-0.1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Use pkgconf for B-D instead of pkg-config.
  * Bump to debhelper-compat 13.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 02 Jul 2024 10:34:50 -0700

albert (0.24.2-0+636.1) stable; urgency=low

  * version number update by debtransform

 -- debtransform <build@opensuse.org>  Tue, 02 Jul 2024 09:26:37 +0000

albert (0.24.2-0) stable; urgency=low

  * See https://raw.githubusercontent.com/albertlauncher/albert/master/CHANGELOG.md

 -- Manuel Schneider <manuelschneid3r@gmail.com>  Sun, 29 Oct 2017 00:00:00 +0000

=== debian/control ===
Source: albert
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Manuel Schneider <manuelschneid3r@gmail.com>
Section: utils
Priority: optional
Standards-Version: 4.1.0
Build-Depends: cmake (>=3.19),
               debhelper-compat (= 13),
               libarchive-dev,
               libgl1-mesa-dev,
               libglvnd-dev,
               libqalculate-dev,
               libqt6opengl6-dev,
               libqt6svg6-dev,
               libxml2-utils,
               lsb-release,
               pkgconf,
               python3-dev (>= 3.7),
               qt6-base-dev,
               qt6-declarative-dev,
               qt6-l10n-tools,
               qt6-scxml-dev,
               qt6-tools-dev,
               qt6-tools-dev-tools
Homepage: https://albertlauncher.github.io/
Vcs-Browser: https://github.com/albertlauncher
Vcs-Git: https://github.com/albertlauncher/albert.git

Package: albert
Architecture: any
Depends: libqt6sql6-sqlite,
         python3-pip,
         qml6-module-qt5compat-graphicaleffects,
         qml6-module-qtqml-statemachine,
         qml6-module-qtqml-workerscript,
         qml6-module-qtquick-shapes,
         qml6-module-qtquick-window,
         qt6-qpa-plugins,
         qt6-wayland,
         ${shlibs:Depends}
Recommends: libqalculate22
Description: Plugin-based C++/Qt keyboard launcher
 Albert is a desktop agnostic keyboard launcher that helps you to accomplish 
 your workflows in a breeze.

=== debian/rules ===
#!/usr/bin/make -f
CODENAME = $(shell lsb_release -cs)
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export QT_SELECT=6

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -D CMAKE_BUILD_TYPE=Release \ 
	                     -D BUILD_PLUGIN_DEBUG=OFF -Wno-inline 

# No dbgsym packages:
override_dh_strip:
	@echo "not building dbgsym packages for MX Linux"
	dh_strip --no-automatic-dbgsym
